<template>
  <div class="form" :style="customColorStyle">
    <div class="row">
      <div class="left col-2">
        <label><h3>{{ $t('type-data') }}</h3></label>
        <div class="dropdown">
          <div v-bind:key="item.id" v-for="item in optDataType" v-bind:value="item.value">
            <input class="form-check-input" type="checkbox" v-model="item.disponible">
            {{ item.libelle }}
          </div>
        </div>
      </div>
      <div class="left col-2">
        <label><h3>{{ $t('system') }}</h3></label>
        <div class="dropdown">
          <div v-bind:key="item.id" v-for="item in optSystem" v-bind:value="item.value">
            <input class="form-check-input" type="checkbox" v-model="item.disponible">
            {{ item.libelle }}
          </div>
        </div>
      </div>
      <div class="left col">
        <label><h3>{{ $t('datasets') }}</h3></label>
        <div class="dropdown">
          <div v-bind:key="item.id" v-for="item in optDataset" v-bind:value="item.value">
            <input class="form-check-input" type="checkbox" v-model="item.disponible">
            {{ item.libelle }}
          </div>
        </div>
      </div>
      <div class="left col">
        <label><h3>{{ $t('model') }}</h3></label>
        <div class="dropdown">
          <div v-bind:key="item.id" v-for="item in optTagModel" v-bind:value="item.value">
            <input class="form-check-input" type="checkbox" v-model="item.disponible">
            {{ item.libelle }}
          </div>
        </div>
      </div>
    </div>
    <div class="center">
      <button @click="validate" class="btn btn-outline-success">{{ $t('send') }}</button>
    </div>
  </div>
</template>

<script>
import custom from '@/shared/custom'
import APIFilter from '@/api/filter'
import APIGcp from '@/api/gcp'
import Vue from 'vue'
export default {
  data () {
    return {
      optDataType: [],
      optDataset: [],
      optTagModel: [],
      optSystem: []
    }
  },
  methods: {
    addAllToList (list) {
      list.unshift({
        id: '*',
        libelle: this.$t('all'),
        disponible: true
      })
      return list
    },
    getAllDataType () {
      this.$store.commit('saveLoading', true)
      const dataTypes = []
      APIGcp.getDataTypes().then(response => {
        response.forEach(item => {
          dataTypes.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optDataType = this.addAllToList(dataTypes)
        this.optDataType = dataTypes.slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllDataset () {
      this.$store.commit('saveLoading', true)
      const datasets = []
      APIGcp.getTDatasets().then(response => {
        response.forEach(item => {
          datasets.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$datasets = this.addAllToList(datasets)
        this.optDataset = datasets.slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllTagName () {
      this.$store.commit('saveLoading', true)
      const optTagModel = []
      APIGcp.getTagModelsWithoutProjectName().then(response => {
        response.forEach(item => {
          optTagModel.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optTagModel = this.addAllToList(optTagModel)
        this.optTagModel = optTagModel.slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllSystemType () {
      this.$store.commit('saveLoading', true)
      const optSystem = []
      APIGcp.getTypeSystems().then(response => {
        response.forEach(item => {
          optSystem.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optSystem = this.addAllToList(optSystem)
        this.optSystem = optSystem.slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    saveDataTypes () {
      APIFilter.saveDataTypes(this.optDataType).then(res => {
        this.$alert(this.$t('success'), this.$t('success'), 'success')
        this.$optDataType = this.addAllToList(res)
      }).catch(() => {
        this.loading = false
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    saveDatasets () {
      APIFilter.saveDatasets(this.optDataset).then(res => {
        this.$optDataType = this.addAllToList(res)
      }).catch(() => {
        this.loading = false
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    saveTagNames () {
      APIFilter.saveTagNames(this.optTagModel).then(res => {
        this.$optDataType = this.addAllToList(res)
      }).catch(() => {
        this.loading = false
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    saveSystemTypes () {
      APIFilter.saveSystemTypes(this.optSystem).then(res => {
        this.$optDataType = this.addAllToList(res)
      }).catch(() => {
        this.loading = false
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    validate () {
      this.saveTagNames()
      this.saveSystemTypes()
      this.saveDatasets()
      this.saveDataTypes()
    },
    getLoadedFilters () {
      if (this.$optDataType) {
        this.optDataType = this.$optDataType.slice(1)
      } else {
        this.getAllDataType()
      }
      if (this.$datasets) {
        this.optDataset = this.$datasets.slice(1)
      } else {
        this.getAllDataset()
      }
      if (this.$optTagModel) {
        this.optTagModel = this.$optTagModel.slice(1)
      } else {
        this.getAllTagName()
      }
      if (this.$optSystem) {
        this.optSystem = this.$optSystem.slice(1)
      } else {
        this.getAllSystemType()
      }
    }
  },
  computed: {
    customColorStyle () {
      return custom.customColorStyle()
    }
  },
  mounted () {
    this.getLoadedFilters()
    custom.getGoodItemAndColorIt(this.$route.path)
  }
}
</script>

<style scoped>
.form {
  margin: 30px 7% 0 7%;
  border-radius: 15px;
  padding: 15px 15px 10px 15px;
}
h3 {
  margin-left: -20px;
}
.btn {
  margin: 15px 10px 0 10px;
}
.top-minus {
  margin-top: -40px;
}
.left {
  margin-left: 30px;
}
.container {
  padding: 0;
  margin: 0;
  width: 100%;
  max-width: 100%;
}
</style>
